# partial unit test for gmpy 0.5 rand functionality
# relies on Tim Peters' "doctest.py" test-driver
# test-version 0.5
r'''
>>> r
<built-in function rand>
>>>
'''

import gmpy as _g, doctest,sys
__test__={}
r = _g.rand

__test__['rand']=\
r'''
>>> r('init',20)
>>> r('qual')
20
>>> r('seed',1234)
>>> for i in range(5):
...     print r('next',100),
...     if i==4: print
...
21 75 63 28 27
>>> alis=list("proktelnu")
>>> for i in range(10):
...     r('shuf',alis)
...     print ''.join(alis)
...
rtoulpnke
eoturlknp
plnuetokr
ekoprulnt
kpoutnrel
rutoneklp
ukeptnorl
onkrlpteu
lknteropu
enrkutlpo
>>> sav=r('save')
>>> print sav
774447212137
>>> for i in range(5):
...     r('shuf',alis)
...     print ''.join(alis)
...
elnuortpk
enutolpkr
eropulntk
plroutenk
ekonrtplu
>>> r('seed',sav)
>>> for i in range(5):
...     r('shuf',alis)
...     print ''.join(alis)
...
epkruotln
ekrtuplno
eoulrpktn
lpourtekn
enukotlpr
>>> r('seed',1234)
>>> for i in range(5):
...     print "%6.4f"%(float(r('floa'))),
...     if i==4: print
...
0.3401 0.3576 0.7713 0.0673 0.2847
>>> r('save')
mpz(313024446023L)
>>> r('init',99)
>>> r('qual')
99
>>> r('seed',1234)
>>> for i in range(5):
...     print "%6.4f"%(float(r('floa'))),
...     if i==4: print
...
0.3634 0.4646 0.4986 0.6965 0.6026
>>> r('save')
mpz(484163514374259245839779527083454657470851924675287295399303L)
>>>
'''

print "Unit tests for gmpy 0.5 pre-alpha (rand functionality)"
print "    running on Python",sys.version
print
print "Testing gmpy %s (GMP %s) with default caching (%s, %s, %s..%s)" % (
    (_g.version(), _g.gmp_version(), _g.get_zcache(), _g.get_qcache(),
    ) + _g.get_zconst())
doctest.testmod(report=0)

print
print "Overall results:"
doctest.master.summarize(1)

